#import <Foundation/Foundation.h>

@interface ThreadedObject : NSObject
@end
@implementation ThreadedObject
- (void)process: (id)ignored
{
	NSLog(@"Work done in another thread goes here");
}
- (void)processInNewThread
{
	SEL sel = @selector(process:);
	[NSThread 
		detachNewThreadSelector: sel
		               toTarget: self
		             withObject: nil];
}
@end

int main(void)
{
	[NSAutoreleasePool new];
	[[ThreadedObject new] processInNewThread];
	sleep(1);
	return 0;
}
